//
//  mdlSignature.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlSignature: Model, Content {
    static let schema = "signature"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Field(key: "name") var name: String
    @Field(key: "type") var type: String
    @Field(key: "data") var data: Data
    @Parent(key: "workOrderId") var workorder: mdlWorkOrder
    @Parent(key: "signatureTypeId") var signaturetype: mdlSignatureType
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         name: String,
         type: String,
         data: Data,
         workorderid: Int,
         createuserid: Int? = -1,
         updateuserid: Int? = -1
    ) {
        self.id = id
        self.name = name
        self.type = type
        self.data = data
        self.$workorder.$id.value = workorderid
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlSignature{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("signature")
                .field("id", .int, .identifier(auto: true))
                .field("name", .string)
                .field("type", .string)
                .field("data", .data)
                .field("workOrderId", .int)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("signature").delete()
        }
    }
    struct Mode1: AsyncMigration{
        func prepare(on database: Database) async throws {
            try await database.schema("signature")
                .field("signatureTypeId", .int, .references("signatureType", "id"))
                .update()
        }
        func revert(on database: Database) async throws {
            try await database.schema("signature")
                .deleteField("signatureTypeId")
                .update()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlSignature>{
        
        let query = mdlSignature.query(on: req.db)
            .with(\.$workorder)
            .with(\.$signaturetype)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

